
package de.ivu.elect.presentation.veranstaltung;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.veranstaltung.boundary.AbstractVeranstaltungSearchParameters;
import de.ivu.elect.business.veranstaltung.boundary.VeranstaltungSearchParameters;
import de.ivu.elect.business.veranstaltung.entity.Veranstaltung;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.veranstaltung.form.VeranstaltungViewFormBuilder;
import de.ivu.elect.presentation.veranstaltung.menu.VeranstaltungDisabledPruefer;

@RequestScoped
@OnlineHilfeId("372")
@Named(AbstractVeranstaltungCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractVeranstaltungCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.VERANSTALTUNG_CREATE)
public class VeranstaltungCreateView extends AbstractVeranstaltungCreateView {

  private static final long serialVersionUID = 1L;

  @Inject
  @ConversationGroup(AbstractVeranstaltungSearchParameters.class)
  private transient VeranstaltungSearchParameters searchParameters;

  @Inject
  private transient VeranstaltungViewFormBuilder veranstaltungViewFormBuilder;

  @Inject
  private transient VeranstaltungDisabledPruefer veranstaltungDisabledPruefer;

  public VeranstaltungCreateView() {
    super();
  }

  @PreConditionCheck
  public String checkCondition() {
    if (veranstaltungDisabledPruefer.isDisabled()) {
      return getStartViewId();
    }

    return null;
  }

  @Override
  public Veranstaltung getEntity() {
    Veranstaltung veranstaltung = super.getEntity();
    veranstaltung.setWahltermin(getSelectedWahltermin());
    veranstaltung.setWahl(getSelectedWahl());
    veranstaltung.setGebiet(getSelectedGebiet());

    return veranstaltung;
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Veranstaltung entity) {
    veranstaltungViewFormBuilder.addProperties(formBuilder, getEntity());
  }

  @Override
  @Redirect
  public String save() {
    getEntity(); // Wahl (und -termin) setzen

    String outcome = super.save();

    // ELECT-4791
    searchParameters.resetVorgegebenePersonendaten();

    return outcome;
  }
}
